/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2000.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2000
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -   David Perry <d.perry@utoronto.ca>
   -   Neil Pryde <NeilPryde92651@netscape.net> (well I'm just HJ's typewriter)
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

////////////////////////////////////////////////////////////////////////////////
function initTabContextMenu()
{
  var popupNode = document.popupNode;

  if (popupNode && popupNode.localName == 'toolbarbutton')
    popupNode = getBrowser().selectedTab;
  else return;

  if (chromeEnabled()) {
    document.getElementById("enableChromeMenuItem").setAttribute("hidden", "true");
  }
  else {
    document.getElementById("enableChromeMenuItem").removeAttribute("hidden");
    document.getElementById("showPersonalToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("hidePersonalToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("showToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("hideToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("activateMaxModeMenuItem").setAttribute("hidden", "true");
    document.getElementById("deactivateMaxModeMenuItem").setAttribute("hidden", "true");
  }
  if (mzToolbox.mToolboxActivated) {
    if (mzToolbox.mPlaceHolder.collapsed) {
      document.getElementById("hideInternalToolboxMenuItem").setAttribute("hidden", "true");
      document.getElementById("showInternalToolboxMenuItem").removeAttribute("hidden");
    }
    else {
      document.getElementById("showInternalToolboxMenuItem").setAttribute("hidden", "true");
      document.getElementById("hideInternalToolboxMenuItem").removeAttribute("hidden");
    }
  }
  if (popupNode.hasAttribute("customLabel")) {
    document.getElementById("setStickyMenuItem").setAttribute("hidden", "true");
    document.getElementById("clearStickyMenuItem").removeAttribute("hidden");
  }
  else {
    document.getElementById("clearStickyMenuItem").setAttribute("hidden", "true");
    document.getElementById("setStickyMenuItem").removeAttribute("hidden");
  }
  if (document.getElementById("cmd_viewpersonaltoolbar").getAttribute("checked") == "true") {
    // hide 'Show Toolbar F10' and show 'Hide Toolbar F10' menu items in tab menu
    document.getElementById("showPersonalToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("hidePersonalToolbarMenuItem").removeAttribute("hidden");
  }
  else {
    // hide 'Hide Toolbar F10' and show 'Hide Toolbar F10' menu items in tab menu
    document.getElementById("hidePersonalToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("showPersonalToolbarMenuItem").removeAttribute("hidden");
  }
  if (document.getElementById("cmd_viewMultiZillaToolbar").getAttribute("checked") == "true") {
    // hide 'Show MultiZilla Toolbar F11' and show 'Hide MultiZilla Toolbar F11' menu items in tab menu
    document.getElementById("showToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("hideToolbarMenuItem").removeAttribute("hidden");
  }
  else {
    // hide 'Hide MultiZilla Toolbar F11' and show 'Hide MultiZilla Toolbar F11' menu items in tab menu
    document.getElementById("hideToolbarMenuItem").setAttribute("hidden", "true");
    document.getElementById("showToolbarMenuItem").removeAttribute("hidden");
  }
  if (window.fullScreen ) {
    // hide 'Show Activate MaxBrowser Mode F12' and show 'Hide Deactivate MaxBrowser Mode F12' menu items in tab menu
    document.getElementById("activateMaxModeMenuItem").setAttribute("hidden", "true");
    document.getElementById("deactivateMaxModeMenuItem").removeAttribute("hidden");
  }
  else {
    // hide 'Hide Deactivate MaxBrowser Mode F12' and show 'Show Activate MaxBrowser Mode F12' menu items in tab menu
    document.getElementById("deactivateMaxModeMenuItem").setAttribute("hidden", "true");
    document.getElementById("activateMaxModeMenuItem").removeAttribute("hidden");
  }
}
////////////////////////////////////////////////////////////////////////////////
function chromeEnabled()
{
  return( !document.documentElement.hasAttribute("chromehidden"));
}
////////////////////////////////////////////////////////////////////////////////
function enableChrome()
{
  if (!chromeEnabled())
    document.documentElement.removeAttribute("chromehidden");
}
////////////////////////////////////////////////////////////////////////////////
function updateTabContextMenu(aPopupMenu)
{
  var disabledValue = "true";
  var menuItems = aPopupMenu.getElementsByAttribute("tbattr", "tabbrowser-multiple");
  
  if (gBrowser.mTabContainer.childNodes.length > 1)
    disabledValue = "false";
  for (var i = 0; i < menuItems.length; i++)
    menuItems[i].setAttribute("disabled", disabledValue);
}
////////////////////////////////////////////////////////////////////////////////
function initTabImportMenu(importMenu) 
{
  var windowManager = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"].getService(nsIWindowDataSource);
  /* var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].
                                 getService(nsIWindowDataSource); */
  // var item = document.getElementById("TabImportWindowSeparator");
  var item = importMenu.childNodes[1];
  while ((item = item.nextSibling)) {
    var url = item.getAttribute('id');
    var win = windowManager.getWindowForResource(url);
    if (win && win == window) {
      item.setAttribute("checked", "true");
      item.setAttribute("disabled", "true");
    }
    else if (!win.getBrowser)
      item.setAttribute("disabled", "true");
  }
  importMenu.firstChild.setAttribute("disabled", (importMenu.childNodes.length == 3) ? "true" : "false");
}
////////////////////////////////////////////////////////////////////////////////
function importTabsByWindowId(aWindowId)
{
  var windowManager = Components.classes["@mozilla.org/rdf/datasource;1?name=window-mediator"].getService(nsIWindowDataSource);
  /* var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].
                                 getService(nsIWindowDataSource); */

  var win = windowManager.getWindowForResource(aWindowId);
  if (!win || win == window) 
    return;
  var winBrowser = win.getBrowser().mPanelContainer;
  var tabCounter = winBrowser.childNodes.length;

  for (var i = 0; i < tabCounter; i++) {
    var url = winBrowser.childNodes[i].currentURI.spec;
    if (url && url != "about:blank")
      getBrowser().addTab(url);
  }
  // win.close();
}
////////////////////////////////////////////////////////////////////////////////
function importAllTabs(aMenuitem)
{
  while ((aMenuitem = aMenuitem.nextSibling)) {
    importTabsByWindowId(aMenuitem.getAttribute('id'));
  }
}
////////////////////////////////////////////////////////////////////////////////
function initTabExportMenu(aParent) 
{
  var tabContainer = gBrowser.mTabContainer; 
  var panelContainer = gBrowser.mPanelContainer; 
  var tabCounter = tabContainer.childNodes.length;

  deleteHistoryItems(aParent); // sessionHistoryUI.js

  for (var i = 0; i < tabCounter; i++) {
    var tabURL = panelContainer.childNodes[i].currentURI.spec;
    var tabLabel = tabContainer.childNodes[i].label;
    var menuitem = document.createElement("menuitem");
    menuitem.setAttribute("label", tabLabel);
    menuitem.setAttribute("url", tabURL);
    menuitem.setAttribute("index", i); // make deleteHistoryItems() work
    menuitem.setAttribute("oncommand", "exportTab(this)");
    aParent.appendChild(menuitem);
    if (tabURL == "about:blank")
      menuitem.setAttribute("disabled", "true");
  }
  aParent.firstChild.setAttribute("disabled", (aParent.childNodes.length == 3) ? "true" : "false");
}
////////////////////////////////////////////////////////////////////////////////
function exportTab(aMenuitem)
{
  if (!aMenuitem.hasAttribute("disabled"))
    window.open(aMenuitem.getAttribute("url"));
}
////////////////////////////////////////////////////////////////////////////////
function exportAllTabs(aMenuitem)
{
  while ((aMenuitem = aMenuitem.nextSibling)) {
    exportTab(aMenuitem)
  }
}