/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
   - Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
   - Henk-Johan van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU General Public License Version 2 or later (the
   - "GPL"), in which case the provisions of the GPL are applicable
   - instead of those above.  If you wish to allow use of your
   - version of this file only under the terms of the GPL and not to
   - allow others to use your version of this file under the MPL,
   - indicate your decision by deleting the provisions above and
   - replace them with the notice and other provisions required by
   - the GPL.  If you do not delete the provisions above, a recipient
   - may use your version of this file under either the MPL or the
   - GPL.
   -
*/

/* 
  modified function from navigator.js with one exception
  function getReferrer(doc) because that belong to contentAreaUtils.js.
  this was added for Phoenix: addPrefListener(observer)
*/

////////////////////////////////////////////////////////////////////////// 
function OpenBookmarkURL(node, datasource, event)
{
  if (node.nodeName == "menu")
    return;
  if (event && (node.id == "bookmarks_groupmark" || node.id == "PT_bookmarks_groupmark"))
    return;
  if (!node.hasChildNodes() && node.getAttribute("group") == "true" && node.hasAttribute("id")) {
    var tabCount = getBrowser().mPanelContainer.childNodes.length-1;
    var newTabs = readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
    var closeRemaining = readMyPref("multizilla.bookmark.close-remaining", "bool", false);
    // open dialog for settings
    if (newTabs == 2) {
      window.openDialog("chrome://multiviews/content/multiviewsAskSettings.xul", "_blank", "chrome,modal,centerscreen", getBrowser(), closeRemaining);
      newTabs = gBrowser.mNewTabs;
      closeRemaining = gBrowser.mRemoveRemaining;
      if (gBrowser.mNewTabs == -1)
        return;
    }
    else newTabs = (newTabs == 1) ? true : false;
    var startTab = newTabs ? tabCount : (closeRemaining ? 0 : tabCount);
    OpenBookmarkFolder(node, datasource, (tabCount+1), newTabs, false, false);
    gBrowser.selectedTab = gBrowser.mTabContainer.childNodes[startTab];

    if (closeRemaining) {
      if (newTabs) {
        /* startTab = gBrowser.mTabList[startTab].ordinal-1;
        for (i = startTab; i >= 0; i--)
          gBrowser.removeTab(gBrowser.mTabList[i]); */
      }
      else {
        for (var i = tabCount; i >= tabIndex; i--)
          gBrowser.removeTab(gBrowser.mTabContainer.childNodes[i]);
      }
    }
    return;
  }
  if (node.getAttribute("container") == "true" || (node.nodeName == "menuitem" && 
      event && event.button == 1))
    return;
  var url = node.getAttribute("id");
  if (!url)
    return;
  try {
    if (datasource) {
      var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
                          .getService(Components.interfaces.nsIRDFService);
      var src = rdf.GetResource(url, true);
      var prop = rdf.GetResource("http://home.netscape.com/NC-rdf#URL", true);
      var target = datasource.GetTarget(src, prop, true);
      if (target) {
        target = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
        if (target)
          url = target;
      }
    }
  } catch (ex) {
    return;
  }
  if (url.substring(0, 3) == "NC:")
    return;
  if (_content) {
    var aTab = null
    if (preventDupeTab(url))
      return;
    while (node.nodeName != "toolbarbutton" && node.nodeName != "menubar")
      node = node.parentNode;
    var shiftKey = false;
    var ctrlKey = false;
    var button = false;
    if (event) {
      shiftKey = event.shiftKey;
      ctrlKey = event.ctrlKey;
      button = event.button;
    }
    if ((node.nodeName == "menubar" && pref && pref.getBoolPref("multizilla.newtabfor.bookmarks") && !shiftKey) ||
        (node.nodeName == "toolbarbutton" /* XXX: see bug 2675 && node.id != "bookmarks-button" */ && 
        pref && pref.getBoolPref("multizilla.newtabfor.personal-toolbar") && !shiftKey) || 
        ctrlKey || button == 1) {
      if (url.substring(0,10) == "javascript") {
	    if (url.indexOf("getSelection(") == -1)
          loadURI(url, null);
        else
          setTimeout(function() { loadURI(url, null) }, 0, getBrowser().selectedTab = getBrowser().addTab());
      }
      else {
        var useTab = checkForBlankTab();
        if (useTab)
          useTab.loadURI(getShortcutOrURI(url, null));
        else 
          aTab = getBrowser().addTab(getShortcutOrURI(url));
      }
      if (pref && !pref.getBoolPref("browser.tabs.loadInBackground"))
        getBrowser().selectedTab = aTab;
    }
    else {
      loadURI(url, null);
    _content.focus();
    }
  }
  else
    openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", url);
}
//////////////////////////////////////////////////////////////////////////
function handleURLBarRevert()
{
  var url = getWebNavigation().currentURI.spec;
  var throbberElement = document.getElementById("navigator-throbber");

  var isScrolling = gURLBar.userAction == "scrolling";
  
  if (!throbberElement.hasAttribute("busy") && !isScrolling) {
    if (url != "about:blank") { 
      gURLBar.value = url;
      gURLBar.select();
      SetPageProxyState("valid", null);
      gBrowser = getBrowser();
      gBrowser.mCurrentBrowser.urlbarTyped = false;
      url = gProxyFavIcon.getAttribute("linked-icon");

      if (gBrowser.mTabbedMode)
        gBrowser.updateCurrentBrowser();
      else if (url) {
        gProxyFavIcon.setAttribute("src", url);
        gProxyDeck.selectedIndex = 1;
      }
    } else {
      gURLBar.value = "";
    }
  }
  return isScrolling; 
}
//////////////////////////////////////////////////////////////////////////
function SetPageProxyState(aState, aURI)
{
  if (!gProxyButton)
    gProxyButton = document.getElementById("page-proxy-button");
  if (!gProxyFavIcon)
    gProxyFavIcon = document.getElementById("page-proxy-favicon");
  if (!gProxyDeck)
    gProxyDeck = document.getElementById("page-proxy-deck");

  if (aState == "valid") {
    gProxyButton.setAttribute("pageproxystate", aState);
    gLastValidURLStr = gURLBar.value;
    gURLBar.addEventListener("input", UpdatePageProxyState, false);
    if (gBrowser.shouldLoadFavIcon(aURI)) {
      var favStr = gBrowser.buildFavIconString(aURI);
      if (favStr != gProxyFavIcon.src) {
        gBrowser.loadFavIcon(aURI, "src", gProxyFavIcon);
        gProxyDeck.selectedIndex = 0;
      }
      else gProxyDeck.selectedIndex = 1;
    }
    else {
      gProxyDeck.selectedIndex = 0;
      gProxyFavIcon.removeAttribute("src");
    }
  } else if (aState == "invalid") {
    gProxyButton.setAttribute("pageproxystate", aState);
    gURLBar.removeEventListener("input", UpdatePageProxyState, false);
    gProxyDeck.selectedIndex = 0;
  } else if (aState == "disabled") {
    gURLBar.removeEventListener("input", UpdatePageProxyState, false);
    gProxyDeck.selectedIndex = 2;
  }
}
//////////////////////////////////////////////////////////////////////////
function BrowserLoadURL(aTriggeringEvent)
{
  var url = gURLBar.value;
  if (url.match(/^view-source:/)) {
    BrowserViewSourceOfURL(url.replace(/^view-source:/, ""), null, null);
  } 
  else {
    if (pref && pref.getBoolPref("browser.tabs.opentabfor.urlbar") &&
        getBrowser().localName == "tabbrowser" &&
        aTriggeringEvent && 'ctrlKey' in aTriggeringEvent &&
        aTriggeringEvent.ctrlKey) {
      var t = getBrowser().addTab(getShortcutOrURI(url)); // open link in new tab
      getBrowser().selectedTab = t;
    }
    else if (pref && pref.getBoolPref("multizilla.newtabfor.locationbar") && 
      getBrowser().localName == "tabbrowser") {
      var aTab = getBrowser().addTab(getShortcutOrURI(url)); // open link in new tab
      getBrowser().selectedTab = aTab;
    }
    else  
      loadURI(getShortcutOrURI(url, null));
    _content.focus();
  }
}
//////////////////////////////////////////////////////////////////////////
function LoadBookmarksCallback()
{
  try {
    if (!gBookmarksService)
      gBookmarksService = Components.classes["@mozilla.org/browser/bookmarks-service;1"]
                                    .getService(Components.interfaces.nsIBookmarksService);
    gBookmarksService.ReadBookmarks();
    var personalToolbar = document.getElementById("NC:PersonalToolbarFolder");
    personalToolbar.builder.rebuild();
  } catch (ex) {
  }
  var chromeHidden = document.documentElement.hasAttribute("chromehidden");
  if (pref && pref.getIntPref("browser.startup.page") == 3 && !chromeHidden)
    OpenBookmarkGroup(null, document.getElementById('BookmarksMenu').database);
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroup(element, datasource, id)
{
  if (!datasource)
    return;
  if (element)
    id = element.getAttribute("id");
  else {
    id = readMyPref("multizilla.tabs.groupmark", "string", null);
    if (!id)
      return;
  }
  var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
  var resource = rdf.GetResource(id, true);
  OpenBookmarkGroupFromResource(resource, datasource, rdf);
}
//////////////////////////////////////////////////////////////////////////
// This is added to maintain backward compatibility. We should remove it 
// when people start using a more recent mozilla build.
//////////////////////////////////////////////////////////////////////////
function updateGroupmarkMenuitem(id)
{
  const disabled = gBrowser.browsers.length == 1;
  document.getElementById(id).setAttribute("disabled", disabled);
}
//////////////////////////////////////////////////////////////////////////
function BrowserViewSourceOfURL(url, charset, pageCookie)
{
  var loadFromURL = true;
  if (readMyPref("multizilla.newtabfor.view-source", "bool", false)) {
    try {
      if (typeof(pageCookie) == "object") {
        if (url != "about:blank")
          gBrowser.selectedTab = gBrowser.addTab('about:blank');
        var PageLoader = getBrowser().webNavigation.QueryInterface(Components.interfaces.nsIWebPageDescriptor);
        PageLoader.LoadPage(pageCookie, Components.interfaces.nsIWebPageDescriptor.DISPLAY_AS_SOURCE);
        loadFromURL = false;
      }
    } catch(ex) { 
	}
    if (loadFromURL)
      gBrowser.addTab('view-source:'+url);
  }
  else {
    openDialog("chrome://navigator/content/viewSource.xul", "_blank",
               "scrollbars,resizable,chrome,dialog=no", url, charset, pageCookie);
  }
}
//////////////////////////////////////////////////////////////////////////
function OpenBookmarkGroupFromResource(resource, datasource, rdf)
{
  var urlResource = rdf.GetResource("http://home.netscape.com/NC-rdf#URL");
  var rdfContainer = Components.classes["@mozilla.org/rdf/container;1"].getService(Components.interfaces.nsIRDFContainer);
  rdfContainer.Init(datasource, resource);
  var containerChildren = rdfContainer.GetElements();
  var tabPanels = gBrowser.mPanelContainer.childNodes;
  var tabCount = tabPanels.length;
  var index = 0;
  for (; containerChildren.hasMoreElements(); ++index) {
    var res = containerChildren.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    var target = datasource.GetTarget(res, urlResource, true);
    if (target) {
      var uri = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      if (!preventDupeTab(uri))
        gBrowser.addTab(uri);
    }
  }  
  if (index == 0)
    return; // If the bookmark group was completely invalid, just bail.
     
  // Select the first tab in the group if we aren't loading in the background.
  if (!pref.getBoolPref("browser.tabs.loadInBackground")) {
    var tabs = gBrowser.mTabContainer.childNodes;
    gBrowser.selectedTab = tabs[tabCount];
  }
}
//////////////////////////////////////////////////////////////////////////
function addPrefListener(observer)
{
  try {
    var pbi = pref.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    pbi.addObserver(observer.domain, observer, false);
  } catch(ex) {
    dump("Failed to observe prefs: " + ex + "\n");
  }
}